#ifndef COLECTION_HPP
#define COLECTION_HPP

#include <QObject>
#include <QList>
#include <QPair>
#include "TrackInfo.hpp"

class QTimer;

class Colection: public QObject
{
    Q_OBJECT
public:
    Colection();
    ~Colection();

public slots:
    void add(const TrackInfoList trackList);
    void getArtists();
    void getAlbums();
    void getTracksFromAlbum(int albumId);
    void getTracksFromArtist(int artistId);
    void getTrackInfo(int trackId);
    void getTracksInfoFromAlbum(int albumId);
    void getTracksInfoFromArtist(int artistId);

signals:
    void gotArtists(QList<QPair<int,QString> > artists);
    void gotAlbums(QList<QPair<int,QString> > albums);
    void gotTracks(QList<QPair<int,QString> > tacks);
    void gotTrackInfo(TrackInfo info);
    void gotTrackFromArtistAlbum(TrackInfoList list);
    void ready();

private slots:
    void connectToDataBase();

private:
    int getArtistId(QString artist);
    int getAlbumId(QString album);

    QThread* myThread;
    QTimer* timer;
};

#endif // COLECTION_HPP
