#ifndef COLECTIONSCANNER_HPP
#define COLECTIONSCANNER_HPP

#include <QObject>
#include <QStringList>
#include "TrackInfo.hpp"

class DirScanner;//used to finde subdirs in the given directory
class DirBuffer;//used to store found directories, used by filescanners

class FileScanner;//scans the directories provided by the DirBuffer
class FileBuffer;//used to store paths to the files found by FileScanners

class ColectionScanner : public QObject
{
    Q_OBJECT
public:
    explicit ColectionScanner(QObject *parent = 0);
    ~ColectionScanner();

    TrackInfoList getFoundTrackInfo() const;

    FileScanner* getFileScaner() const;

signals:
    void scanCompleat();
    void searchPath(QString path);
    void starFileSearch(QStringList seachSuffixList);

public slots:
    void starScan(QString dirPath,QStringList suffixList);
    void cancelScan();

private slots:
    void dirScanCompleat();
    void fileScaneCompleat();

private:
    DirBuffer* dirBuffer;
    DirScanner* dirScanner;

    FileBuffer* fileBuffer;
    FileScanner* fileScanner;
    QStringList currentSuffixList;
};

#endif // COLECTIONSCANNER_HPP
