#include "DirScanner.hpp"
#include <QThread>
#include <QDirIterator>
#include "DirBuffer.hpp"


void DirScanner::stop()
{
    run = false;
}

void DirScanner::starDirScan(QString dirPath)
{
    run = true;
    QDirIterator iterator(dirPath,QDir::Files,QDirIterator::Subdirectories);
    myBuffer->clear();
    while(iterator.hasNext())
    {
        myBuffer->append(iterator.next());
        if(!run)
        {
            myBuffer->clear();
            return;
        }
    }
    emit dirScanFinished();
}

DirScanner::DirScanner(DirBuffer* buffer)
    :QObject(0),myBuffer(buffer)
{
    run = true;
    myThread = new QThread;
    this->moveToThread(myThread);
    myThread->start();
}

DirScanner::~DirScanner()
{
    myThread->exit();
    myThread->wait();
    delete myThread;
}
