#ifndef FILESCANNER_HPP
#define FILESCANNER_HPP

#include <QObject>
#include <QStringList>

class DirBuffer;
class FileBuffer;
class QTimer;

class FileScanner : public QObject
{
    Q_OBJECT
public:
    explicit FileScanner(DirBuffer* dirBuffer,FileBuffer* fileBuffer);
    ~FileScanner();

    void stop();
    void dirScanFinished();

signals:
    void scannFinished();
    void scanningFile(QString);

public slots:
    void startScan(QStringList suffixList);

private slots:
    void scanNext();

private:
    DirBuffer* myDirBuffer;
    FileBuffer* myFileBuffer;
    QThread* myThread;
    QTimer* timer;
    QStringList currentSuffixList;
    bool dirScannRunning;
    bool run;
};

#endif // FILESCANNER_HPP
