#ifndef TRACKINFO_HPP
#define TRACKINFO_HPP

#include <QList>
#include <QString>
#include <QMetaType>
#include <QDataStream>

struct TrackInfo
{
    QString artistName;
    QString album;
    QString title;
    QString path;
    QString runTime;

    TrackInfo()
        :artistName(""),album(""),title(""),path(""),runTime("")
    {}

    TrackInfo(const TrackInfo& other)
        :artistName(other.artistName),album(other.album),title(other.title),path(other.path),
        runTime(other.runTime)
    {}

    bool operator==(const TrackInfo& other) const
    {
        if(other.artistName == artistName && other.album == album && other.title == title &&
           other.path == path && other.runTime == runTime)
            return true;
        return false;
    }

    bool operator<(const TrackInfo& other) const
    {
        if(other.artistName > artistName)
            return true;
        else if(other.artistName == artistName)
        {
            if(other.album > album)
                return true;
            else if(other.album == album)
            {
                if(other.title > title)
                    return true;
                else if(other.title == title)
                {
                    if(other.path > path)
                        return true;
                    else if(path == other.path)
                    {
                        if(other.runTime > path)
                            return true;
                    }
                }
            }
        }
        return false;
    }

    bool operator>(const TrackInfo& other) const
    {
        if(other.artistName < artistName)
            return true;
        else if(other.artistName == artistName)
        {
            if(other.album < album)
                return true;
            else if(other.album == album)
            {
                if(other.title < title)
                    return true;
                else if(other.title == title)
                {
                    if(other.path < path)
                        return true;
                    else if(path == other.path)
                    {
                        if(other.runTime < path)
                            return true;
                    }
                }
            }
        }
        return false;
    }
};

inline QDataStream& operator<<(QDataStream& out, const TrackInfo& info)
{
    out << info.artistName;
    out << info.album;
    out << info.title;
    out << info.path;
    out << info.runTime;
    return out;
}

inline QDataStream& operator>>(QDataStream& in, TrackInfo& info)
{
    in >> info.artistName;
    in >> info.album;
    in >> info.title;
    in >> info.path;
    in >> info.runTime;
    return in;
}

typedef QList<TrackInfo> TrackInfoList;

Q_DECLARE_METATYPE(TrackInfo)

#endif // TRACKINFO_HPP
