#include "ClearItem.hpp"
#include <QPainter>
#include <QGraphicsSceneMouseEvent>
#include <QCursor>
#include <QLinearGradient>

QRectF ClearItem::boundingRect() const
{
    return QRectF(0.0f,0.0f,15.0f,15.0f);
}

void ClearItem::paint(QPainter* painter,const QStyleOptionGraphicsItem*,QWidget*)
{
    painter->setRenderHint(QPainter::Antialiasing);
    painter->setPen(QColor(55,55,55));
    QLinearGradient gradient(boundingRect().topRight(),boundingRect().bottomRight());
    gradient.setColorAt(0.0f,QColor(255,255,255,0));
    gradient.setColorAt(0.1f,QColor(255,255,255,0));
    gradient.setColorAt(1.0f,QColor(255,255,255,155));
    painter->setBrush(gradient);
    painter->drawPath(path);
}

void ClearItem::mousePressEvent(QGraphicsSceneMouseEvent* event)
{
    event->accept();
    if(event->button() == Qt::LeftButton)
        emit clicked();
}

ClearItem::ClearItem(QGraphicsItem* parent)
    :QGraphicsObject(parent)
{
    this->setZValue(2);
    path.moveTo(0.0f,boundingRect().center().y());
    path.lineTo(boundingRect().center().x(),0.0f);
    path.lineTo(boundingRect().center().x(),boundingRect().bottom());
    path.lineTo(0.0f,boundingRect().center().y());
    path.closeSubpath();
    path.moveTo(boundingRect().topRight());
    path.lineTo(boundingRect().bottomRight());
    path.lineTo(boundingRect().right() - (boundingRect().width() * 0.25f),boundingRect().bottom());
    path.lineTo(boundingRect().right() - (boundingRect().width() * 0.25f),boundingRect().top());
    path.lineTo(boundingRect().topRight());

    setCursor(QCursor(Qt::PointingHandCursor));
}
