#ifndef COLECTIONITEM_HPP
#define COLECTIONITEM_HPP

#include <QGraphicsObject>

class ColectionItem : public QGraphicsObject
{
    Q_OBJECT
    Q_PROPERTY(qreal vPos READ getVPos WRITE setVPos);
    Q_PROPERTY(qreal hPos READ getHPos WRITE setHPos);
public:
    explicit ColectionItem(qreal width,int index,QString text,QGraphicsItem* parent = 0);

    virtual ColectionItem* newInstance(qreal width,int index,QString text,QGraphicsItem* parent);

    QRectF boundingRect() const;

    qreal getWidth() const;
    qreal getVPos() const;
    qreal getHPos() const;

    void setWidth(qreal width);
    void setVPos(qreal vpos);
    void setHPos(qreal hpos);

    void slideUp();
    void slideDown();

    QString getText() const;

signals:
    void clicked(int index);

protected:
    virtual void paint(QPainter* painter,const QStyleOptionGraphicsItem* option,QWidget* widget);
    virtual void mousePressEvent(QGraphicsSceneMouseEvent* event);
    void hoverEnterEvent(QGraphicsSceneHoverEvent* event);
    void hoverLeaveEvent(QGraphicsSceneHoverEvent* event);

protected:
    qreal myWidth;
    int myIndex;
    QString myText;
    bool hover;
};

#endif // COLECTIONITEM_HPP
