#ifndef COLECTIONTOOLBAR_HPP
#define COLECTIONTOOLBAR_HPP

#include <QGraphicsItem>

class GraphicsToolButton;
class VolumeControl;

class ColectionToolBar : public QGraphicsItem
{
public:
    explicit ColectionToolBar(qreal width,QGraphicsItem* parent = 0);
    QRectF boundingRect() const;

    GraphicsToolButton* addToolButtonLeft(QPixmap icon);
    GraphicsToolButton* addToolButtonRight(QPixmap icon);

    VolumeControl* getVolumeControl() const;

    void setWidth(qreal width);

protected:
    void paint(QPainter* painter,const QStyleOptionGraphicsItem* option,QWidget* widget);

private:
    void arrangeButtons();

    QList<GraphicsToolButton*> leftButtons;
    QList<GraphicsToolButton*> rightButtons;

    VolumeControl* myControl;

    qreal myWidth;
};

#endif // COLECTIONTOOLBAR_HPP
