#ifndef FILTERINPUT_HPP
#define FILTERINPUT_HPP

#include <QGraphicsObject>

class QGraphicsProxyWidget;
class QLineEdit;
class ClearItem;

class FilterInput : public QGraphicsObject
{
    Q_OBJECT
public:
    explicit FilterInput(qreal width,qreal heigh,QGraphicsItem* parent = 0);

    QRectF boundingRect() const;

    void resize(qreal w,qreal h);

protected:
    void paint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget);

signals:
    void applayFilter(QString filter);

public slots:
    void filterChanged();
    void clearFilter();

private:
    qreal myWidth;
    qreal myHeigh;
    QGraphicsProxyWidget* proxy;
    QLineEdit* edit;
    ClearItem* item;
};

#endif // FILTERINPUT_HPP
