#ifndef GRAPHICSTOOLBUTTON_HPP
#define GRAPHICSTOOLBUTTON_HPP

#include <QGraphicsObject>

class GraphicsToolButton : public QGraphicsObject
{
    Q_OBJECT
public:
    explicit GraphicsToolButton(QPixmap icon,QGraphicsItem* parent = 0);
    QRectF boundingRect() const;

    void setEnabled(bool enabled);

protected:
    void paint(QPainter* painter,const QStyleOptionGraphicsItem* option,QWidget* widget);
    void mousePressEvent(QGraphicsSceneMouseEvent* event);
    void hoverEnterEvent(QGraphicsSceneHoverEvent* event);
    void hoverLeaveEvent(QGraphicsSceneHoverEvent* event);

signals:
    void clicked();

private:
    QPixmap image;
    QPixmap disabledImage;
    bool hover;
    bool enabled;
};

#endif // GRAPHICSTOOLBUTTON_HPP
