#ifndef SCROLLBUTTON_HPP
#define SCROLLBUTTON_HPP

#include <QGraphicsObject>

namespace Scroll
{
    typedef quint8 dir;
    const dir up = 0;
    const dir down = 1;
}

class ScrollButton : public QGraphicsObject
{
    Q_OBJECT
public:
    explicit ScrollButton(Scroll::dir direction,QGraphicsItem* parent = 0);

    QRectF boundingRect() const;

protected:
    void paint(QPainter* painter,const QStyleOptionGraphicsItem* option,QWidget* widget);
    void mousePressEvent(QGraphicsSceneMouseEvent* event);
    void mouseReleaseEvent(QGraphicsSceneMouseEvent* event);

signals:
    void scroll();

private slots:
    void timerTick();

private:
    Scroll::dir myDirection;
    QTimer* timer;
};

#endif // SCROLLBUTTON_HPP
