#include "TrackItem.hpp"
#include <QGraphicsSceneMouseEvent>
#include <QDrag>
#include <QMimeData>
#include <QApplication>
#include <QPainter>

ColectionItem* TrackItem::newInstance(qreal width,int index,QString text,
                                      QGraphicsItem* parent)
{
    return new TrackItem(width,index,text,parent);
}

void TrackItem::paint(QPainter* painter,const QStyleOptionGraphicsItem *option,QWidget* widget)
{
    ColectionItem::paint(painter,option,widget);
    painter->drawPixmap(2,2,QPixmap(":/eyecandy/track.png"));
}

void TrackItem::mousePressEvent(QGraphicsSceneMouseEvent* event)
{
    event->accept();
    dragStart = event->pos();
}

void TrackItem::mouseReleaseEvent(QGraphicsSceneMouseEvent* event)
{
    event->accept();
    emit clicked(myIndex);
}

void TrackItem::mouseMoveEvent(QGraphicsSceneMouseEvent* event)
{
    event->accept();
    if((event->pos() - dragStart).manhattanLength() < QApplication::startDragDistance() &&
       event->button() != Qt::LeftButton)
        return;
    QDrag* drag = new QDrag(event->widget());
    QMimeData *mime = new QMimeData;
    drag->setMimeData(mime);
    mime->setData("VulcanoPlayer/TrackIndex",QByteArray::number(myIndex));
    QPixmap dragPixmap(":/eyecandy/track.png");
    drag->setPixmap(dragPixmap);
    drag->setHotSpot(QPoint(dragPixmap.width()/2,
                            dragPixmap.height()/2));
    drag->exec();
}

TrackItem::TrackItem(qreal width,int index,QString text,QGraphicsItem* parent)
    :ColectionItem(width,index,text,parent)
{
}
