#ifndef VOLUMESLIDER_HPP
#define VOLUMESLIDER_HPP

#include <QGraphicsObject>

class VolumeSlider : public QGraphicsObject
{
    Q_OBJECT
public:
    explicit VolumeSlider(QGraphicsItem* parent = 0);

    QRectF boundingRect() const;

    void setValue(qreal newVolumne);

protected:
    void paint(QPainter* painter,const QStyleOptionGraphicsItem* option,QWidget* widget);
    void mousePressEvent(QGraphicsSceneMouseEvent* event);
    void mouseMoveEvent(QGraphicsSceneMouseEvent* event);

signals:
    void valueChanged(qreal newValue);

private:
    qreal value;
    QPainterPath path;
};

#endif // VOLUMESLIDER_HPP
