#ifndef PLAYLISTITEM_HPP
#define PLAYLISTITEM_HPP

#include "../Display/ColectionItem.hpp"
#include "../Colection/TrackInfo.hpp"

class PlayListItem : public ColectionItem
{
    Q_OBJECT
public:
    explicit PlayListItem(qreal width,TrackInfo info,QGraphicsItem* parent = 0);

    QString getPath() const;
    TrackInfo getTrackInfo() const;

    void setCurrent(bool current);

protected:
    void paint(QPainter* painter,const QStyleOptionGraphicsItem* option,QWidget* widget);
    void mousePressEvent(QGraphicsSceneMouseEvent* event);
    void mouseDoubleClickEvent(QGraphicsSceneMouseEvent* event);
    void mouseMoveEvent(QGraphicsSceneMouseEvent* event);

signals:
    void clicked(PlayListItem* item);
    void remove(PlayListItem* item);

private:
    TrackInfo myTrackInfo;
    bool current;
    QPointF dragStart;
};

#endif // PLAYLISTITEM_HPP
