#ifndef SEEKERITEM_HPP
#define SEEKERITEM_HPP

#include <QGraphicsObject>

class SeekerItem : public QGraphicsObject
{
    Q_OBJECT
public:
    explicit SeekerItem(qreal width,QGraphicsItem* parent = 0);

    QRectF boundingRect() const;

    void changeWidth(qreal width);

protected:
    void paint(QPainter* painter,const QStyleOptionGraphicsItem* option,QWidget* widget);
    void mousePressEvent(QGraphicsSceneMouseEvent* event);
    void mouseMoveEvent(QGraphicsSceneMouseEvent* event);

public slots:
    void trackLeanghtChanged(qint64 leangh);
    void currentTimeChanged(qint64 current);

signals:
    void tryToJup(qint64 dest);

private:
    qreal myWidth;
    qint64 trackLeanght;
    qint64 currentTime;
    QPainterPath clipPath;
};

#endif // SEEKERITEM_HPP
